; MultiMain, 2008-01-27.
; demo by kero <geocities.com/xmemor>

.386
.model flat,stdcall
option casemap:none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32

.data
 _class   db "MultiMain_%10.10lu",0
 _title   db "%s_%lu",0 
 _button  db "button",0
 _help    db "    MultiMain  by  kero      //      Exit:    F12      //      Create  new  window  thread:    F11,    or  any  big  button  of  the  previous  threads    ",0
 rect     RECT <10,10,90,60>

.data?
 hinst    dd ?

.code

MessageLoop proc
  local msg:MSG
  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
  .endw
  mov eax,msg.wParam
  ret
MessageLoop endp

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
  local wc:WNDCLASSEX
  local hWnd:HWND
  local buf[32]:BYTE
  
  mov wc.cbSize,sizeof WNDCLASSEX
  mov wc.style,CS_DBLCLKS
  mov wc.lpfnWndProc,offset WndProc
  mov wc.cbClsExtra,0
  mov wc.cbWndExtra,0
  mov eax,hInst
  mov wc.hInstance,eax
  mov wc.lpszMenuName,0
  invoke LoadIcon,0,IDI_APPLICATION
  mov wc.hIcon,eax
  mov wc.hIconSm,eax
  invoke LoadCursor,0,IDC_HAND
  mov wc.hCursor,eax
  
  invoke GetTickCount
  push eax
  push eax
  invoke GetTickCount
  and eax,0ffffh
  pop ecx  
  shl eax,8
  mov al,cl
  invoke CreateSolidBrush,eax
  mov wc.hbrBackground,eax
  pop eax
  invoke wsprintf,addr buf,offset _class,eax
  lea eax,buf
  mov wc.lpszClassName,eax
  
  invoke RegisterClassEx,addr wc
  
  invoke CreateWindowEx,WS_EX_CLIENTEDGE OR WS_EX_TOPMOST OR WS_EX_TOOLWINDOW,addr buf,0,WS_OVERLAPPEDWINDOW,300,0,240,180,0,0,hInst,0
  mov hWnd,eax
  invoke ShowWindow,hWnd,SW_SHOWDEFAULT
  invoke UpdateWindow,hWnd
    
  invoke MessageLoop
  push eax
  invoke UnregisterClass,addr buf,hInst
  pop eax
  ret
WinMain endp

SubProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  .if uMsg==WM_DESTROY
    invoke DestroyWindow,hWnd
    xor eax,eax
  .else
    invoke GetWindowLong,hWnd,GWL_USERDATA
    invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  .endif
  ret
SubProc endp

ThreadProc proc param:DWORD
  invoke WinMain,hinst,0,0,SW_SHOWDEFAULT
  invoke ExitThread,0
  ret
ThreadProc endp

WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local ps:PAINTSTRUCT
  local buf[32]:BYTE
  
  mov eax,hWnd
  .if uMsg==WM_DESTROY
    invoke PostQuitMessage,0
    xor eax,eax
    
  .elseif uMsg==WM_CREATE
    invoke CreateWindowEx,0,addr _button,0,WS_VISIBLE OR WS_CHILD, 10,80,80,24,hWnd,3000,hinst,0
    invoke CreateWindowEx,0,addr _button,0,WS_VISIBLE OR WS_CHILD,110,10,40,24,hWnd,3001,hinst,0
    invoke GetClassName,hWnd,addr buf,31    
    mov ebx,hWnd
    jmp @f

  .elseif uMsg==WM_COMMAND && wParam==3001
    invoke GetClassName,hWnd,addr buf,31
    invoke CreateWindowEx,WS_EX_CLIENTEDGE OR WS_EX_TOPMOST OR WS_EX_TOOLWINDOW,addr buf,0,WS_OVERLAPPEDWINDOW OR WS_VISIBLE,0,0,210,150,0,0,hinst,0
    mov ebx,eax
    invoke SetWindowLong,ebx,GWL_WNDPROC,addr SubProc
    invoke SetWindowLong,ebx,GWL_USERDATA,eax
@@:
    invoke GetWindowThreadProcessId,ebx,0
    invoke wsprintf,addr buf,offset _title,addr buf,eax
    invoke SetWindowText,ebx,addr buf    
    xor eax,eax
    
  .elseif uMsg==WM_COMMAND && wParam==3000
    invoke CreateThread,0,0,offset ThreadProc,0,0,0
    invoke CloseHandle,eax
    xor eax,eax    

  .elseif uMsg==WM_PAINT
    invoke BeginPaint,hWnd,addr ps
    mov ebx,eax
    invoke GetStockObject,BLACK_BRUSH
    invoke FillRect,ebx,addr rect,eax
    invoke GetStockObject,WHITE_BRUSH
    invoke FrameRect,ebx,addr rect,eax
    invoke EndPaint,hWnd,addr ps
    xor eax,eax
    
  .else
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
  .endif
  ret
WndProc endp

ScreenText proc uses ebx edi lpstr:LPSTR
  invoke MessageBeep,0
  invoke GetDC,0
  mov ebx,eax
;  invoke GetStockObject,DEFAULT_GUI_FONT
;  invoke SelectObject,ebx,eax
;  mov edi,eax
  invoke lstrlen,lpstr
  invoke TextOut,ebx,0,0,lpstr,eax
;  invoke SelectObject,ebx,edi
  invoke ReleaseDC,0,ebx
  ret
ScreenText endp

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke ScreenText,offset _help
@0:
  invoke Sleep,50
  invoke GetKeyState,VK_F11
  and eax,8000h
  jz @1
  invoke InvalidateRect,0,0,1
@2:
  invoke Sleep,10  ;   
  invoke GetKeyState,VK_F11
  and eax,8000h
  jnz @2
  invoke CreateThread,0,0,offset ThreadProc,0,0,0
  invoke CloseHandle,eax
@1:  
  invoke GetKeyState,VK_F12
  and eax,8000h
  jz @0
  invoke MessageBeep,0
  invoke InvalidateRect,0,0,1
  invoke ExitProcess,eax
end start
